Index: serefpolicy-contrib-20140730/qmail.if
===================================================================
--- serefpolicy-contrib-20140730.orig/qmail.if
+++ serefpolicy-contrib-20140730/qmail.if
@@ -1,12 +1,12 @@
-## <summary>Qmail Mail Server.</summary>
+## <summary>Qmail Mail Server</summary>
 
 ########################################
 ## <summary>
-##	Template for qmail parent/sub-domain pairs.
+##	Template for qmail parent/sub-domain pairs
 ## </summary>
 ## <param name="child_prefix">
 ##	<summary>
-##	The prefix of the child domain.
+##	The prefix of the child domain
 ##	</summary>
 ## </param>
 ## <param name="parent_domain">
@@ -16,35 +16,39 @@
 ## </param>
 #
 template(`qmail_child_domain_template',`
-	gen_require(`
-		attribute qmail_child_domain;
-	')
-
-	########################################
-	#
-	# Declarations
-	#
-
-	type $1_t, qmail_child_domain;
-	type $1_exec_t;
+	type $1_t;
 	domain_type($1_t)
+	type $1_exec_t;
 	domain_entry_file($1_t, $1_exec_t)
-
+	domain_auto_trans($2, $1_exec_t, $1_t)
 	role system_r types $1_t;
 
-	########################################
-	#
-	# Policy
-	#
+	allow $1_t self:process signal_perms;
+
+	allow $1_t $2:fd use;
+	allow $1_t $2:fifo_file rw_file_perms;
+	allow $1_t $2:process sigchld;
+
+	allow $1_t qmail_etc_t:dir list_dir_perms;
+	allow $1_t qmail_etc_t:file read_file_perms;
+	allow $1_t qmail_etc_t:lnk_file read_lnk_file_perms;
+
+	allow $1_t qmail_start_t:fd use;
+
+	kernel_list_proc($2)
+	kernel_read_proc_symlinks($2)
 
-	domtrans_pattern($2, $1_exec_t, $1_t)
+	corecmd_search_bin($1_t)
+
+	files_search_var($1_t)
+
+	fs_getattr_xattr_fs($1_t)
 
-	kernel_read_system_state($2)
 ')
 
 ########################################
 ## <summary>
-##	Transition to qmail_inject_t.
+##	Transition to qmail_inject_t
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -57,11 +61,11 @@ interface(`qmail_domtrans_inject',`
 		type qmail_inject_t, qmail_inject_exec_t;
 	')
 
+	corecmd_search_bin($1)
 	domtrans_pattern($1, qmail_inject_exec_t, qmail_inject_t)
 
 	ifdef(`distro_debian',`
 		files_search_usr($1)
-		corecmd_search_bin($1)
 	',`
 		files_search_var($1)
 	')
@@ -69,7 +73,7 @@ interface(`qmail_domtrans_inject',`
 
 ########################################
 ## <summary>
-##	Transition to qmail_queue_t.
+##	Transition to qmail_queue_t
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -82,11 +86,11 @@ interface(`qmail_domtrans_queue',`
 		type qmail_queue_t, qmail_queue_exec_t;
 	')
 
+	corecmd_search_bin($1)
 	domtrans_pattern($1, qmail_queue_exec_t, qmail_queue_t)
 
 	ifdef(`distro_debian',`
 		files_search_usr($1)
-		corecmd_search_bin($1)
 	',`
 		files_search_var($1)
 	')
@@ -108,20 +112,21 @@ interface(`qmail_read_config',`
 		type qmail_etc_t;
 	')
 
-	files_search_var($1)
 	allow $1 qmail_etc_t:dir list_dir_perms;
 	allow $1 qmail_etc_t:file read_file_perms;
 	allow $1 qmail_etc_t:lnk_file read_lnk_file_perms;
+	files_search_var($1)
 
 	ifdef(`distro_debian',`
+		# handle /etc/qmail
 		files_search_etc($1)
 	')
 ')
 
 ########################################
 ## <summary>
-##	Define the specified domain as a
-##	qmail-smtp service.
+##	Define the specified domain as a qmail-smtp service. 
+##	Needed by antivirus/antispam filters.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -141,3 +146,59 @@ interface(`qmail_smtpd_service_domain',`
 
 	domtrans_pattern(qmail_smtpd_t, $2, $1)
 ')
+
+########################################
+## <summary>
+##      Create, read, write, and delete qmail
+##      spool directories.
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
+#
+interface(`qmail_manage_spool_dirs',`
+        gen_require(`
+                type qmail_spool_t;
+        ')
+
+        manage_dirs_pattern($1, qmail_spool_t, qmail_spool_t)
+')
+
+########################################
+## <summary>
+##      Create, read, write, and delete qmail
+##      spool files.
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
+#
+interface(`qmail_manage_spool_files',`
+        gen_require(`
+                type qmail_spool_t;
+        ')
+
+        manage_files_pattern($1, qmail_spool_t, qmail_spool_t)
+')
+
+########################################
+## <summary>
+##      Read and write to qmail spool pipes.
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain to not audit.
+##      </summary>
+## </param>
+#
+interface(`qmail_rw_spool_pipes',`
+        gen_require(`
+                type qmail_spool_t;
+        ')
+
+        allow $1 qmail_spool_t:fifo_file rw_fifo_file_perms;
+')
Index: serefpolicy-contrib-20140730/qmail.te
===================================================================
--- serefpolicy-contrib-20140730.orig/qmail.te
+++ serefpolicy-contrib-20140730/qmail.te
@@ -1,11 +1,11 @@
-policy_module(qmail, 1.7.0)
+policy_module(qmail, 1.6.1)
 
 ########################################
 #
 # Declarations
 #
 
-attribute qmail_child_domain;
+attribute qmail_user_domains;
 
 type qmail_alias_home_t;
 files_type(qmail_alias_home_t)
@@ -18,7 +18,7 @@ files_config_file(qmail_etc_t)
 type qmail_exec_t;
 files_type(qmail_exec_t)
 
-type qmail_inject_t;
+type qmail_inject_t, qmail_user_domains;
 type qmail_inject_exec_t;
 domain_type(qmail_inject_t)
 domain_entry_file(qmail_inject_t, qmail_inject_exec_t)
@@ -32,21 +32,25 @@ qmail_child_domain_template(qmail_lspawn
 mta_mailserver_delivery(qmail_lspawn_t)
 
 qmail_child_domain_template(qmail_queue, qmail_inject_t)
+typeattribute qmail_queue_t qmail_user_domains;
 mta_mailserver_user_agent(qmail_queue_t)
 
 qmail_child_domain_template(qmail_remote, qmail_rspawn_t)
 mta_mailserver_sender(qmail_remote_t)
 
 qmail_child_domain_template(qmail_rspawn, qmail_start_t)
+
 qmail_child_domain_template(qmail_send, qmail_start_t)
+
 qmail_child_domain_template(qmail_smtpd, qmail_tcp_env_t)
+
 qmail_child_domain_template(qmail_splogger, qmail_start_t)
 
 type qmail_keytab_t;
 files_type(qmail_keytab_t)
 
 type qmail_spool_t;
-files_type(qmail_spool_t)
+files_spool_file(qmail_spool_t)
 
 type qmail_start_t;
 type qmail_start_exec_t;
@@ -58,28 +62,8 @@ application_domain(qmail_tcp_env_t, qmai
 
 ########################################
 #
-# Common qmail child domain local policy
-#
-
-allow qmail_child_domain self:process signal_perms;
-
-allow qmail_child_domain qmail_etc_t:dir list_dir_perms;
-allow qmail_child_domain qmail_etc_t:file read_file_perms;
-allow qmail_child_domain qmail_etc_t:lnk_file read_lnk_file_perms;
-
-allow qmail_child_domain qmail_start_t:fd use;
-
-corecmd_search_bin(qmail_child_domain)
-
-files_search_var(qmail_child_domain)
-
-fs_getattr_xattr_fs(qmail_child_domain)
-
-miscfiles_read_localization(qmail_child_domain)
-
-########################################
-#
-# Clean local policy
+# qmail-clean local policy
+#	this component cleans up the queue directory
 #
 
 read_files_pattern(qmail_clean_t, qmail_spool_t, qmail_spool_t)
@@ -87,11 +71,12 @@ delete_files_pattern(qmail_clean_t, qmai
 
 ########################################
 #
-# Inject local policy
+# qmail-inject local policy
+#	this component preprocesses mail from stdin and invokes qmail-queue
 #
 
-allow qmail_inject_t self:fifo_file write_fifo_file_perms;
 allow qmail_inject_t self:process signal_perms;
+allow qmail_inject_t self:fifo_file write_fifo_file_perms;
 
 allow qmail_inject_t qmail_queue_exec_t:file read_file_perms;
 
@@ -99,18 +84,18 @@ corecmd_search_bin(qmail_inject_t)
 
 files_search_var(qmail_inject_t)
 
-miscfiles_read_localization(qmail_inject_t)
 
 qmail_read_config(qmail_inject_t)
 
 ########################################
 #
-# Local local policy
+# qmail-local local policy
+#	this component delivers a mail message
 #
 
-allow qmail_local_t self:fifo_file write_fifo_file_perms;
 allow qmail_local_t self:process signal_perms;
-allow qmail_local_t self:unix_stream_socket { accept listen };
+allow qmail_local_t self:fifo_file write_file_perms;
+allow qmail_local_t self:unix_stream_socket create_stream_socket_perms;
 
 manage_dirs_pattern(qmail_local_t, qmail_alias_home_t, qmail_alias_home_t)
 manage_files_pattern(qmail_local_t, qmail_alias_home_t, qmail_alias_home_t)
@@ -137,12 +122,17 @@ mta_append_spool(qmail_local_t)
 qmail_domtrans_queue(qmail_local_t)
 
 optional_policy(`
+	uucp_domtrans(qmail_local_t)
+')
+
+optional_policy(`
 	spamassassin_domtrans_client(qmail_local_t)
 ')
 
 ########################################
 #
-# Lspawn local policy
+# qmail-lspawn local policy
+#	this component schedules local deliveries
 #
 
 allow qmail_lspawn_t self:capability { setuid setgid };
@@ -156,21 +146,23 @@ allow qmail_lspawn_t qmail_local_exec_t:
 
 read_files_pattern(qmail_lspawn_t, qmail_spool_t, qmail_spool_t)
 
-files_read_etc_files(qmail_lspawn_t)
+corecmd_search_bin(qmail_lspawn_t)
+
 files_search_pids(qmail_lspawn_t)
 files_search_tmp(qmail_lspawn_t)
 
 ########################################
 #
-# Queue local policy
+# qmail-queue local policy
+#	this component places a mail in a delivery queue, later to be processed by qmail-send
 #
 
 allow qmail_queue_t qmail_lspawn_t:fd use;
 allow qmail_queue_t qmail_lspawn_t:fifo_file write_fifo_file_perms;
 
+allow qmail_queue_t qmail_smtpd_t:process sigchld;
 allow qmail_queue_t qmail_smtpd_t:fd use;
 allow qmail_queue_t qmail_smtpd_t:fifo_file read_fifo_file_perms;
-allow qmail_queue_t qmail_smtpd_t:process sigchld;
 
 manage_dirs_pattern(qmail_queue_t, qmail_spool_t, qmail_spool_t)
 manage_files_pattern(qmail_queue_t, qmail_spool_t, qmail_spool_t)
@@ -186,28 +178,34 @@ optional_policy(`
 
 ########################################
 #
-# Remote local policy
+# qmail-remote local policy
+#	this component sends mail via SMTP
 #
 
+allow qmail_remote_t self:tcp_socket create_socket_perms;
+allow qmail_remote_t self:udp_socket create_socket_perms;
+
 rw_files_pattern(qmail_remote_t, qmail_spool_t, qmail_spool_t)
 
-corenet_all_recvfrom_unlabeled(qmail_remote_t)
 corenet_all_recvfrom_netlabel(qmail_remote_t)
 corenet_tcp_sendrecv_generic_if(qmail_remote_t)
+corenet_udp_sendrecv_generic_if(qmail_remote_t)
 corenet_tcp_sendrecv_generic_node(qmail_remote_t)
-
-corenet_sendrecv_smtp_client_packets(qmail_remote_t)
-corenet_tcp_connect_smtp_port(qmail_remote_t)
+corenet_udp_sendrecv_generic_node(qmail_remote_t)
 corenet_tcp_sendrecv_smtp_port(qmail_remote_t)
+corenet_udp_sendrecv_dns_port(qmail_remote_t)
+corenet_tcp_connect_smtp_port(qmail_remote_t)
+corenet_sendrecv_smtp_client_packets(qmail_remote_t)
 
 dev_read_rand(qmail_remote_t)
 dev_read_urand(qmail_remote_t)
 
-sysnet_dns_name_resolve(qmail_remote_t)
+sysnet_read_config(qmail_remote_t)
 
 ########################################
 #
-# Rspawn local policy
+# qmail-rspawn local policy
+#	this component scedules remote deliveries
 #
 
 allow qmail_rspawn_t self:process signal_perms;
@@ -217,9 +215,12 @@ allow qmail_rspawn_t qmail_remote_exec_t
 
 rw_files_pattern(qmail_rspawn_t, qmail_spool_t, qmail_spool_t)
 
+corecmd_search_bin(qmail_rspawn_t)
+
 ########################################
 #
-# Send local policy
+# qmail-send local policy
+#	this component delivers mail messages from the queue
 #
 
 allow qmail_send_t self:process signal_perms;
@@ -237,7 +238,8 @@ optional_policy(`
 
 ########################################
 #
-# Smtpd local policy
+# qmail-smtpd local policy
+#	this component receives mails via SMTP
 #
 
 allow qmail_smtpd_t self:process signal_perms;
@@ -268,26 +270,26 @@ optional_policy(`
 
 ########################################
 #
-# Splogger local policy
+# splogger local policy
+#	this component creates entries in syslog
 #
 
 allow qmail_splogger_t self:unix_dgram_socket create_socket_perms;
 
-files_read_etc_files(qmail_splogger_t)
 
 init_dontaudit_use_script_fds(qmail_splogger_t)
 
-miscfiles_read_localization(qmail_splogger_t)
 
 ########################################
 #
-# Start local policy
+# qmail-start local policy
+#	this component starts up the mail delivery component
 #
 
 allow qmail_start_t self:capability { setgid setuid };
 dontaudit qmail_start_t self:capability sys_tty_config;
-allow qmail_start_t self:fifo_file rw_fifo_file_perms;
 allow qmail_start_t self:process signal_perms;
+allow qmail_start_t self:fifo_file rw_fifo_file_perms;
 
 can_exec(qmail_start_t, qmail_start_exec_t)
 
@@ -304,7 +306,8 @@ optional_policy(`
 
 ########################################
 #
-# Tcp-env local policy
+# tcp-env local policy
+#	this component sets up TCP-related environment variables
 #
 
 allow qmail_tcp_env_t qmail_smtpd_exec_t:file read_file_perms;
Index: serefpolicy-contrib-20140730/qpid.if
===================================================================
--- serefpolicy-contrib-20140730.orig/qpid.if
+++ serefpolicy-contrib-20140730/qpid.if
@@ -1,4 +1,4 @@
-## <summary>Apache QPID AMQP messaging server.</summary>
+## <summary>policy for qpidd</summary>
 
 ########################################
 ## <summary>
@@ -15,31 +15,12 @@ interface(`qpidd_domtrans',`
 		type qpidd_t, qpidd_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, qpidd_exec_t, qpidd_t)
 ')
 
-#####################################
-## <summary>
-##	Read and write access qpidd semaphores.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`qpidd_rw_semaphores',`
-	gen_require(`
-		type qpidd_t;
-	')
-
-	allow $1 qpidd_t:sem rw_sem_perms;
-')
-
 ########################################
 ## <summary>
-##	Read and write qpidd shared memory.
+##	Execute qpidd server in the qpidd domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -47,36 +28,36 @@ interface(`qpidd_rw_semaphores',`
 ##	</summary>
 ## </param>
 #
-interface(`qpidd_rw_shm',`
+interface(`qpidd_initrc_domtrans',`
 	gen_require(`
-		type qpidd_t;
+		type qpidd_initrc_exec_t;
 	')
 
-	allow $1 qpidd_t:shm rw_shm_perms;
+	init_labeled_script_domtrans($1, qpidd_initrc_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute qpidd init script in
-##	the initrc domain.
+##	Read qpidd PID files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed to transition.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`qpidd_initrc_domtrans',`
+interface(`qpidd_read_pid_files',`
 	gen_require(`
-		type qpidd_initrc_exec_t;
+		type qpidd_var_run_t;
 	')
 
-	init_labeled_script_domtrans($1, qpidd_initrc_exec_t)
+	files_search_pids($1)
+	allow $1 qpidd_var_run_t:file read_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Read qpidd pid files.
+##	Manage qpidd var_run files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -84,13 +65,15 @@ interface(`qpidd_initrc_domtrans',`
 ##	</summary>
 ## </param>
 #
-interface(`qpidd_read_pid_files',`
+interface(`qpidd_manage_var_run',`
 	gen_require(`
 		type qpidd_var_run_t;
 	')
 
 	files_search_pids($1)
-	allow $1 qpidd_var_run_t:file read_file_perms;
+	manage_dirs_pattern($1, qpidd_var_run_t, qpidd_var_run_t)
+	manage_files_pattern($1, qpidd_var_run_t, qpidd_var_run_t)
+	manage_lnk_files_pattern($1, qpidd_var_run_t, qpidd_var_run_t)
 ')
 
 ########################################
@@ -108,8 +91,8 @@ interface(`qpidd_search_lib',`
 		type qpidd_var_lib_t;
 	')
 
-	files_search_var_lib($1)
 	allow $1 qpidd_var_lib_t:dir search_dir_perms;
+	files_search_var_lib($1)
 ')
 
 ########################################
@@ -153,38 +136,102 @@ interface(`qpidd_manage_lib_files',`
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an qpidd environment.
+##	Manage qpidd var_lib files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="role">
+#
+interface(`qpidd_manage_var_lib',`
+	gen_require(`
+		type qpidd_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	manage_dirs_pattern($1, qpidd_var_lib_t, qpidd_var_lib_t)
+	manage_files_pattern($1, qpidd_var_lib_t, qpidd_var_lib_t)
+	manage_lnk_files_pattern($1, qpidd_var_lib_t, qpidd_var_lib_t)
+')
+
+#####################################
+## <summary>
+##	Allow read and write access to qpidd semaphores.
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	Role allowed access.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <rolecap/>
 #
-interface(`qpidd_admin',`
+interface(`qpidd_rw_semaphores',`
 	gen_require(`
-		type qpidd_t, qpidd_initrc_exec_t, qpidd_var_lib_t;
-		type qpidd_var_run_t;
+		type qpidd_t;
 	')
 
-	allow $1 qpidd_t:process { ptrace signal_perms };
-	ps_process_pattern($1, qpidd_t)
+	allow $1 qpidd_t:sem rw_sem_perms;
+')
 
-	qpidd_initrc_domtrans($1)
-	domain_system_change_exemption($1)
-	role_transition $2 qpidd_initrc_exec_t system_r;
-	allow $2 system_r;
+#######################################
+## <summary>
+##  Read and write to qpidd shared memory.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`qpidd_rw_shm',`
+	gen_require(`
+		type qpidd_t;
+		type qpidd_tmpfs_t;
+	')
 
-	files_search_var_lib($1)
-	admin_pattern($1, qpidd_var_lib_t)
+	allow $1 qpidd_t:shm rw_shm_perms;
+	fs_search_tmpfs($1)
+	manage_files_pattern($1, qpidd_tmpfs_t, qpidd_tmpfs_t)
+')
 
-	files_search_pids($1)
-	admin_pattern($1, qpidd_var_run_t)
+#######################################
+## <summary>
+##  All of the rules required to
+##  administrate an qpidd environment.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+## <param name="role">
+##  <summary>
+##  Role allowed access.
+##  </summary>
+## </param>
+## <rolecap/>
+#
+interface(`qpidd_admin',`
+    gen_require(`
+        type qpidd_t, qpidd_initrc_exec_t, qpidd_var_lib_t;
+        type qpidd_var_run_t;
+    ')
+
+    allow $1 qpidd_t:process { signal_perms };
+    ps_process_pattern($1, qpidd_t)
+
+    tunable_policy(`deny_ptrace',`',`
+        allow $1 qpidd_t:process ptrace;
+    ')
+
+    qpidd_initrc_domtrans($1)
+    domain_system_change_exemption($1)
+    role_transition $2 qpidd_initrc_exec_t system_r;
+    allow $2 system_r;
+
+    files_search_var_lib($1)
+    admin_pattern($1, qpidd_var_lib_t)
+
+    files_search_pids($1)
+    admin_pattern($1, qpidd_var_run_t)
 ')
Index: serefpolicy-contrib-20140730/qpid.te
===================================================================
--- serefpolicy-contrib-20140730.orig/qpid.te
+++ serefpolicy-contrib-20140730/qpid.te
@@ -12,6 +12,9 @@ init_daemon_domain(qpidd_t, qpidd_exec_t
 type qpidd_initrc_exec_t;
 init_script_file(qpidd_initrc_exec_t)
 
+type qpidd_tmp_t;
+files_tmp_file(qpidd_tmp_t)
+
 type qpidd_tmpfs_t;
 files_tmpfs_file(qpidd_tmpfs_t)
 
@@ -33,41 +36,52 @@ allow qpidd_t self:shm create_shm_perms;
 allow qpidd_t self:tcp_socket { accept listen };
 allow qpidd_t self:unix_stream_socket { accept listen };
 
+manage_dirs_pattern(qpidd_t, qpidd_tmp_t, qpidd_tmp_t)
+manage_files_pattern(qpidd_t, qpidd_tmp_t, qpidd_tmp_t)
+files_tmp_filetrans(qpidd_t, qpidd_tmp_t, { dir file })
+
 manage_dirs_pattern(qpidd_t, qpidd_tmpfs_t, qpidd_tmpfs_t)
 manage_files_pattern(qpidd_t, qpidd_tmpfs_t, qpidd_tmpfs_t)
 fs_tmpfs_filetrans(qpidd_t, qpidd_tmpfs_t, { dir file })
 
-manage_dirs_pattern(qpidd_t, qpidd_var_lib_t, qpidd_var_lib_t)
-manage_files_pattern(qpidd_t, qpidd_var_lib_t, qpidd_var_lib_t)
+manage_dirs_pattern(qpidd_t, qpidd_var_lib_t,  qpidd_var_lib_t)
+manage_files_pattern(qpidd_t, qpidd_var_lib_t,  qpidd_var_lib_t)
 files_var_lib_filetrans(qpidd_t, qpidd_var_lib_t, { file dir })
 
-manage_dirs_pattern(qpidd_t, qpidd_var_run_t, qpidd_var_run_t)
-manage_files_pattern(qpidd_t, qpidd_var_run_t, qpidd_var_run_t)
+manage_dirs_pattern(qpidd_t, qpidd_var_run_t,  qpidd_var_run_t)
+manage_files_pattern(qpidd_t, qpidd_var_run_t,  qpidd_var_run_t)
 files_pid_filetrans(qpidd_t, qpidd_var_run_t, { file dir })
 
 kernel_read_system_state(qpidd_t)
 
-corenet_all_recvfrom_unlabeled(qpidd_t)
 corenet_all_recvfrom_netlabel(qpidd_t)
+corenet_tcp_bind_generic_node(qpidd_t)
 corenet_tcp_sendrecv_generic_if(qpidd_t)
 corenet_tcp_sendrecv_generic_node(qpidd_t)
-corenet_tcp_bind_generic_node(qpidd_t)
 
 corenet_sendrecv_amqp_server_packets(qpidd_t)
 corenet_tcp_bind_amqp_port(qpidd_t)
 corenet_tcp_sendrecv_amqp_port(qpidd_t)
 
+corenet_tcp_bind_matahari_port(qpidd_t)
+corenet_tcp_connect_matahari_port(qpidd_t)
+
 dev_read_sysfs(qpidd_t)
 dev_read_urand(qpidd_t)
+dev_read_rand(qpidd_t)
 
-files_read_etc_files(qpidd_t)
+# needed by ssl
+files_list_tmp(qpidd_t)
 
 logging_send_syslog_msg(qpidd_t)
 
-miscfiles_read_localization(qpidd_t)
-
 sysnet_dns_name_resolve(qpidd_t)
 
 optional_policy(`
-	corosync_stream_connect(qpidd_t)
+    kerberos_use(qpidd_t)
 ')
+
+optional_policy(`
+	rhcs_stream_connect_cluster(qpidd_t)
+')
+
Index: serefpolicy-contrib-20140730/quantum.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/quantum.fc
+++ serefpolicy-contrib-20140730/quantum.fc
@@ -1,10 +1,31 @@
-/etc/rc\.d/init\.d/quantum.*	--	gen_context(system_u:object_r:quantum_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/neutron.*	--	gen_context(system_u:object_r:neutron_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/quantum.*	--	gen_context(system_u:object_r:neutron_initrc_exec_t,s0)
 
-/usr/bin/quantum-server	--	gen_context(system_u:object_r:quantum_exec_t,s0)
-/usr/bin/quantum-openvswitch-agent	--	gen_context(system_u:object_r:quantum_exec_t,s0)
-/usr/bin/quantum-linuxbridge-agent	--	gen_context(system_u:object_r:quantum_exec_t,s0)
-/usr/bin/quantum-ryu-agent	--	gen_context(system_u:object_r:quantum_exec_t,s0)
+/usr/bin/neutron-dhcp-agent     --  gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/neutron-l3-agent       --  gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/neutron-lbaas-agent	--	gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/neutron-metadata-agent    --  gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/neutron-netns-cleanup --  gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/neutron-ns-metadata-proxy --  gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/neutron-rootwrap	--	gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/neutron-linuxbridge-agent	--	gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/neutron-openvswitch-agent	--	gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/neutron-ovs-cleanup    --  gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/neutron-ryu-agent	--	gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/neutron-server	--	gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/quantum-dhcp-agent     --  gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/quantum-l3-agent       --  gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/quantum-linuxbridge-agent	--	gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/quantum-openvswitch-agent	--	gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/quantum-ovs-cleanup    --  gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/quantum-ryu-agent	--	gen_context(system_u:object_r:neutron_exec_t,s0)
+/usr/bin/quantum-server	--	gen_context(system_u:object_r:neutron_exec_t,s0)
 
-/var/lib/quantum(/.*)?	gen_context(system_u:object_r:quantum_var_lib_t,s0)
+/usr/lib/systemd/system/neutron.*	--	gen_context(system_u:object_r:neutron_unit_file_t,s0)
+/usr/lib/systemd/system/quantum.*	--	gen_context(system_u:object_r:neutron_unit_file_t,s0)
 
-/var/log/quantum(/.*)?	gen_context(system_u:object_r:quantum_log_t,s0)
+/var/lib/neutron(/.*)?	gen_context(system_u:object_r:neutron_var_lib_t,s0)
+/var/lib/quantum(/.*)?	gen_context(system_u:object_r:neutron_var_lib_t,s0)
+
+/var/log/neutron(/.*)?	gen_context(system_u:object_r:neutron_log_t,s0)
+/var/log/quantum(/.*)?	gen_context(system_u:object_r:neutron_log_t,s0)
Index: serefpolicy-contrib-20140730/quantum.if
===================================================================
--- serefpolicy-contrib-20140730.orig/quantum.if
+++ serefpolicy-contrib-20140730/quantum.if
@@ -2,41 +2,294 @@
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an quantum environment.
+##	Transition to neutron.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`neutron_domtrans',`
+	gen_require(`
+		type neutron_t, neutron_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, neutron_exec_t, neutron_t)
+')
+
+########################################
+## <summary>
+##	Allow read/write neutron pipes
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="role">
+#
+interface(`neutron_rw_inherited_pipes',`
+	gen_require(`
+		type neutron_t;
+	')
+
+	allow $1 neutron_t:fifo_file rw_inherited_fifo_file_perms;
+')
+
+########################################
+## <summary>
+##	Send sigchld to neutron.
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	Role allowed access.
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+#
+interface(`neutron_sigchld',`
+	gen_require(`
+		type neutron_t;
+	')
+
+    allow $1 neutron_t:process sigchld;
+')
+
+########################################
+## <summary>
+##	Read neutron's log files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 ## <rolecap/>
 #
-interface(`quantum_admin',`
+interface(`neutron_read_log',`
+	gen_require(`
+		type neutron_log_t;
+	')
+
+	logging_search_logs($1)
+	read_files_pattern($1, neutron_log_t, neutron_log_t)
+')
+
+########################################
+## <summary>
+##	Append to neutron log files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`neutron_append_log',`
+	gen_require(`
+		type neutron_log_t;
+	')
+
+	logging_search_logs($1)
+	append_files_pattern($1, neutron_log_t, neutron_log_t)
+')
+
+########################################
+## <summary>
+##	Manage neutron log files
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`neutron_manage_log',`
+	gen_require(`
+		type neutron_log_t;
+	')
+
+	logging_search_logs($1)
+	manage_dirs_pattern($1, neutron_log_t, neutron_log_t)
+	manage_files_pattern($1, neutron_log_t, neutron_log_t)
+	manage_lnk_files_pattern($1, neutron_log_t, neutron_log_t)
+')
+
+########################################
+## <summary>
+##	Search neutron lib directories.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`neutron_search_lib',`
+	gen_require(`
+		type neutron_var_lib_t;
+	')
+
+	allow $1 neutron_var_lib_t:dir search_dir_perms;
+	files_search_var_lib($1)
+')
+
+########################################
+## <summary>
+##	Read neutron lib files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`neutron_read_lib_files',`
 	gen_require(`
-		type quantum_t, quantum_initrc_exec_t, quantum_log_t;
-		type quantum_var_lib_t, quantum_tmp_t;
+		type neutron_var_lib_t;
 	')
 
-	allow $1 quantum_t:process { ptrace signal_perms };
-	ps_process_pattern($1, quantum_t)
+	files_search_var_lib($1)
+	read_files_pattern($1, neutron_var_lib_t, neutron_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Manage neutron lib files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`neutron_manage_lib_files',`
+	gen_require(`
+		type neutron_var_lib_t;
+	')
 
-	init_labeled_script_domtrans($1, quantum_initrc_exec_t)
-	domain_system_change_exemption($1)
-	role_transition $2 quantum_initrc_exec_t system_r;
-	allow $2 system_r;
+	files_search_var_lib($1)
+	manage_files_pattern($1, neutron_var_lib_t, neutron_var_lib_t)
+    manage_sock_files_pattern($1, neutron_var_lib_t, neutron_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Manage neutron lib directories.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`neutron_manage_lib_dirs',`
+	gen_require(`
+		type neutron_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	manage_dirs_pattern($1, neutron_var_lib_t, neutron_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Read and write neutron fifo files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`neutron_rw_fifo_file',`
+	gen_require(`
+		type neutron_t;
+	')
+
+	allow $1 neutron_t:fifo_file rw_inherited_fifo_file_perms;
+')
+
+#####################################
+## <summary>
+##	Connect to neutron over a unix domain
+##	stream socket.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`neutron_stream_connect',`
+	gen_require(`
+        type neutron_t;
+		type neutron_var_lib_t;
+	')
+
+	files_search_pids($1)
+	stream_connect_pattern($1, neutron_var_lib_t, neutron_var_lib_t, neutron_t )
+')
+
+########################################
+## <summary>
+##	Execute neutron server in the neutron domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`neutron_systemctl',`
+	gen_require(`
+		type neutron_t;
+		type neutron_unit_file_t;
+	')
+
+	systemd_exec_systemctl($1)
+	systemd_read_fifo_file_passwd_run($1)
+	allow $1 neutron_unit_file_t:file read_file_perms;
+	allow $1 neutron_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, neutron_t)
+')
+
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an neutron environment
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`neutron_admin',`
+	gen_require(`
+		type neutron_t;
+		type neutron_log_t;
+		type neutron_var_lib_t;
+		type neutron_unit_file_t;
+	')
+
+	allow $1 neutron_t:process { ptrace signal_perms };
+	ps_process_pattern($1, neutron_t)
 
 	logging_search_logs($1)
-	admin_pattern($1, quantum_log_t)
+	admin_pattern($1, neutron_log_t)
 
 	files_search_var_lib($1)
-	admin_pattern($1, quantum_var_lib_t)
+	admin_pattern($1, neutron_var_lib_t)
 
-	files_search_tmp($1)
-	admin_pattern($1, quantum_tmp_t)
+	neutron_systemctl($1)
+	admin_pattern($1, neutron_unit_file_t)
+	allow $1 neutron_unit_file_t:service all_service_perms;
+	optional_policy(`
+		systemd_passwd_agent_exec($1)
+		systemd_read_fifo_file_passwd_run($1)
+	')
 ')
